# coding: utf-8

"""
    ABX Service - APIs

    Create or manage actions and their versions. Execute actions and flows.  This page describes the RESTful APIs for ABX Service. The APIs facilitate CRUD operations on creation and management of Actions and their Versions and also allow Execution of Actions and Flows.  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across ABX Service APIs.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/abx/api/resources/actions?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/abx/api/resources/actions?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/abx/api/resources/actions?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /abx/api/resources/actions?$filter=startswith(name, 'ABC')     /abx/api/resources/actions?$filter=toupper(name) eq 'ABCD-ACTION'     /abx/api/resources/actions?$filter=substringof(%27bc%27,tolower(name))     /abx/api/resources/actions?$filter=name eq 'ABCD' and actionType eq 'SCRIPT'   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ActionCountById(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cnt': 'int',
        'projects': 'str',
        'name': 'str',
        'id': 'str',
        'has_shared': 'bool'
    }

    attribute_map = {
        'cnt': 'cnt',
        'projects': 'projects',
        'name': 'name',
        'id': 'id',
        'has_shared': 'hasShared'
    }

    def __init__(self, cnt=None, projects=None, name=None, id=None, has_shared=None):  # noqa: E501
        """ActionCountById - a model defined in Swagger"""  # noqa: E501
        self._cnt = None
        self._projects = None
        self._name = None
        self._id = None
        self._has_shared = None
        self.discriminator = None
        if cnt is not None:
            self.cnt = cnt
        if projects is not None:
            self.projects = projects
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if has_shared is not None:
            self.has_shared = has_shared

    @property
    def cnt(self):
        """Gets the cnt of this ActionCountById.  # noqa: E501


        :return: The cnt of this ActionCountById.  # noqa: E501
        :rtype: int
        """
        return self._cnt

    @cnt.setter
    def cnt(self, cnt):
        """Sets the cnt of this ActionCountById.


        :param cnt: The cnt of this ActionCountById.  # noqa: E501
        :type: int
        """

        self._cnt = cnt

    @property
    def projects(self):
        """Gets the projects of this ActionCountById.  # noqa: E501


        :return: The projects of this ActionCountById.  # noqa: E501
        :rtype: str
        """
        return self._projects

    @projects.setter
    def projects(self, projects):
        """Sets the projects of this ActionCountById.


        :param projects: The projects of this ActionCountById.  # noqa: E501
        :type: str
        """

        self._projects = projects

    @property
    def name(self):
        """Gets the name of this ActionCountById.  # noqa: E501


        :return: The name of this ActionCountById.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ActionCountById.


        :param name: The name of this ActionCountById.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def id(self):
        """Gets the id of this ActionCountById.  # noqa: E501


        :return: The id of this ActionCountById.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ActionCountById.


        :param id: The id of this ActionCountById.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def has_shared(self):
        """Gets the has_shared of this ActionCountById.  # noqa: E501


        :return: The has_shared of this ActionCountById.  # noqa: E501
        :rtype: bool
        """
        return self._has_shared

    @has_shared.setter
    def has_shared(self, has_shared):
        """Sets the has_shared of this ActionCountById.


        :param has_shared: The has_shared of this ActionCountById.  # noqa: E501
        :type: bool
        """

        self._has_shared = has_shared

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ActionCountById, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ActionCountById):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
